/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fxlib.h"
#include "TIMER_FX2.H"


//------------------------------------------------------------------------------
int KeyCheckAC(void)		// [AC]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 1 ) && (kcode2 == 1 ) ) flag0=1; // [AC] is down
	}
 	return flag0;
}

int KeyCheckEXE(void)		// [EXE]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 3 ) && (kcode2 == 2 ) ) flag0=1; // [EXE] is down
	}
 	return flag0;
}

int KeyCheckPlusMinus(void)	// (-)
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 2 ) ) flag0=1; // [(-)] is down
	}
 	return flag0;
}


//------------------------------------------------------------------------------
void circle(x,y,r)
{
	double	pi=3.14159265359, angle, x0,y0,x1,y1;
	int	i,n=16;
	x0=r+x;
	y0=0+y;
	for(i=1;i<=n;i++){
		angle=pi*2*i/n;
		x1=cos(angle)*r+x;
		y1=sin(angle)*r+y;
		Bdisp_DrawLineVRAM(x0,y0,x1,y1);
		x0=x1;
		y0=y1;
		Bdisp_PutDisp_DD();
	}
}

//------------------------------------------------------------------------------
void montecarlo_gr(int skip)
{
	int i=0, o=0, j=0, s,t;
	double x,y;
	char buffer[21];
	unsigned int key;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"MonteCarlo");
	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	
	Bdisp_DrawLineVRAM( 64, 0,127, 0);
	Bdisp_DrawLineVRAM( 64,63,127,63);
	Bdisp_DrawLineVRAM( 64, 0, 64,63);
	Bdisp_DrawLineVRAM(127, 0,127,63);
	circle(96,32,31);

	s=RTC_GetTicks();
	
	while (1) {

		x=rand()/(RAND_MAX+1.0);
		y=rand()/(RAND_MAX+1.0);
		if ( x*x+y*y < 1 ) o+=1;
		i++;
		
		Bdisp_SetPoint_VRAM(96+32*(x*2-1), 32+32*(y*2-1), 1);

		j++;
		if ( j>=skip ) { j=0;
			t=RTC_GetTicks()-s;
			locate(1,2); sprintf(buffer,"C =%d",i);							Print((unsigned char*)buffer);
			locate(1,3); sprintf(buffer,"PI=%7.5f",(double)o*4/(double)i);	Print((unsigned char*)buffer);
			locate(1,5); sprintf(buffer,"t=%5.2fs",(double)t/128);				Print((unsigned char*)buffer);
			Bdisp_PutDisp_DD();
			if ( KeyCheckPlusMinus() ) {
				locate(1,7); Print((unsigned char*)"EXE:Start");
				while ( 1 )  { GetKey(&key);
					if ( key == KEY_CTRL_EXE  ) break;		// [EXE]
					if ( key == KEY_CTRL_AC   ) return;		// [AC]
				}	
				locate(1,7); Print((unsigned char*)"(-):Stop ");
				s=RTC_GetTicks()-t;
			}	
			if ( KeyCheckAC() ) return;
		}
	}

}


void montecarlo_bench(int num, int skip)
{
	int i=0, k, o=0, j=0, t,t0=0;
	double x,y;
	char buffer[21];
	unsigned int key;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"MonteCarlo bench");
	Bdisp_PutDisp_DD();

	while (1) {
		start_timer();	// --------------------------------------
	
		for( k=1; k<=num; k++){
			x=rand()/(RAND_MAX+1.0);
			y=rand()/(RAND_MAX+1.0);
			if ( x*x+y*y < 1 ) o+=1;
			i++;

			j++;
			if ( j>=skip ) { j=0;
				locate(1,2); sprintf(buffer,"C =%d",i);							Print((unsigned char*)buffer);
				locate(1,3); sprintf(buffer,"PI=%7.5f",(double)o*4/(double)i);	Print((unsigned char*)buffer);
				Bdisp_PutDisp_DD();
			}
		}

		t=get_timer()+t0;	// --------------------------------------
		locate(1,5);sprintf(buffer,"time=%5.3fs",(float)t/1000); Print((unsigned char*)buffer);
	
		locate(1,7); Print((unsigned char*)"EXE:Continue");
		locate(1,8); Print((unsigned char*)"AC :Exit");
		Bdisp_PutDisp_DD();
		while ( 1 )  { GetKey(&key);
			if ( key == KEY_CTRL_EXE  ) break;		// [EXE]
			if ( key == KEY_CTRL_AC   ) return;		// [AC]
		}	
		locate(1,7); Print((unsigned char*)"            ");
		locate(1,8); Print((unsigned char*)"        ");
		t0=t;
	}
}



//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;

	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		locate(1,1);Print((unsigned char*)"F1:MonteCarlo 1/1");
		locate(1,2);Print((unsigned char*)"F2:MonteCarlo 1/10");
		locate(1,3);Print((unsigned char*)"F3:MonteCarlo 1/100");
		locate(1,5);Print((unsigned char*)"F5:MonteCarlo bench");
		locate(1,6);Print((unsigned char*)"F6:MonteCarlo bench 2");
		
		GetKey(&key);
		switch (key) {
//			case KEY_CTRL_EXIT:
//				cont=0;
//				break;
				
			case KEY_CTRL_F1:
				montecarlo_gr(1);
				break;
			case KEY_CTRL_F2:
				montecarlo_gr(10);
				break;
			case KEY_CTRL_F3:
				montecarlo_gr(100);
				break;

			case KEY_CTRL_F5:
				montecarlo_bench(1000,1);
				break;
			case KEY_CTRL_F6:
				montecarlo_bench(100000,10000);
				break;
				
			default:
				break;
		}
	}

	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

